﻿#define adOpenForwardOnly 0
#define adOpenKeyset 1
#define adOpenDynamic 2
#define adOpenStatic 3
#define adLockReadOnly 1
#define adLockPessimistic 2
#define adLockOptimistic 3
#define adLockBatchOptimistic 4
#define adUseNone 1
#define adUseServer 2
#define adUseClient 3
#define adStateClose 

#xtranslate TEXT SQL TO <v>  => #pragma __text|<v>+=%s;<v>:="" 
/*
Definições do grid genérico
*/
PROCEDURE Main

   LOCAL oRs , oCn, cSql, cSQLReturn, cSQLNext, lNextPage := .t. , lPreviousPage := .t.
   LOCAL cString := "Driver={Microsoft Access Driver (*.mdb, *.accdb)};DBQ=" + PathBase() + "/scott.mdb"
   LOCAL hReg 
   LOCAL aReg := {}, aHead := {}, aWidth := {}
   LOCAL hGet := AP_GetPairs()
   LOCAL nPagina := VAL( hb_HGetDef( hGet , "pagina" , "1" )) // Se não informar a página recebe 1 (primeira página) 
   LOCAL nRegistroPorPagina := 3
   LOCAL hResult
   

   oCn := win_oleCreateObject( "ADODB.Connection" ) 
   oCn:ConnectionString := cString
   oCn:Open()
   
   oRs := win_oleCreateObject( "ADODB.Recordset" ) 
   oRs:CursorLocation = adUseClient
    
   
   TEXT SQL TO cSQL
      
        SELECT TOP :registroPorPagina tb01.*
            FROM emp AS tb01
            LEFT JOIN (
                SELECT TOP :offset empno FROM emp ORDER BY empno ASC
            ) AS tb02
            ON tb01.empno = tb02.empno
        WHERE ISNULL(tb02.empno)
        ORDER BY tb01.empno ASC
   
   ENDTEXT
   
   cSQLReturn := StrTran( cSQL , ":registroPorPagina" , hb_ntos( nRegistroPorPagina ) )
   cSQLReturn := StrTran( cSQLReturn , ":offset" , hb_ntos( nRegistroPorPagina * ( nPagina  )  ) ) 
   
  
   oRs:Open( cSQLReturn , oCn , adOpenDynamic, adLockOptimistic )

   if oRs:recordcount > 0
        oRs:Movefirst()
        do while !oRs:eof()
            hReg := {=>}
            hReg[ "___pk" ] := oRs:fields("empno"):value 
            hReg[ "ename" ] := oRs:fields("ename"):value 
            hReg[ "job" ] := oRs:fields("job"):value 
            hReg[ "deptno" ] := oRs:fields("deptno"):value 
            AADD( aReg , hReg )
            oRs:movenext()
        enddo
    endif    
    oRs:Close()
    
    

   /* A próxima página existe ? */
   cSQLNext := StrTran( cSQL , ":registroPorPagina" , hb_ntos( nRegistroPorPagina ) )
   cSQLNext := StrTran( cSQLNext , ":offset" , hb_ntos( nRegistroPorPagina * ( nPagina+1  )  ) ) 
   oRs:Open( cSQLNext , oCn , adOpenDynamic, adLockOptimistic )
   if oRs:recordcount == 0
       lNextPage := .f.
    endif   
   /* A página anterior existe ? */
   if nPagina-1 <= 0
       lPreviousPage := .f.
    endif
    
    /* Agora vou preparar o retorno no formato JSON. Primeiro o Hash hResult
       vai acumular os valores */
    hResult := { => }
    
    /*
     Vai ter botão de alteração, inclusão e de exclusão ?
     Geralmente essa resposta vem de alguma outra rotina, tipo aquela 
     que define "níveis de acesso" ao usuário.
     Não vamos criar essa rotina agora. Por isso vou pressupor que todo grid
     terá tais botões. A seguir:
    */ 
    hResult[ "HasUpdateButton" ] := .t. 
    hResult[ "HasDeleteButton" ] := .t. 
    hResult[ "HasInsertButton" ] := .t.    
    /* ---------------- */
    
    hResult[ "Result" ] := "OK" 
    hResult[ "NextPage" ] := lNextPage
    hResult[ "PreviousPage" ] := lPreviousPage
    
    /* Head (Nome das colunas) */
    AADD( aHead , "Nome" );AADD( aWidth , "50%" ) // 50%
    AADD( aHead , "Cargo" );AADD( aWidth , "30%" ) // 50% + 20% = 70%
    AADD( aHead , "Dept" );AADD( aWidth , "10%" ) // 70% + 10% = 80%
    IF hResult[ "HasUpdateButton" ]
        AADD( aHead , "Alteração" );AADD( aWidth , "10%" ) // 80% + 10% = 90%
    ENDIF    
    IF hResult[ "HasDeleteButton" ]
        AADD( aHead , "Exclusão" );AADD( aWidth , "10%" ) // 90% + 10% = 100% (Largura total)
    ENDIF    
    hResult[ "Header" ] := aHead
    /* --------------------------------------------------- */
    
    hResult[ "Rows" ] := aReg
    hResult[ "Width" ] := aWidth
    
    /* Depois de concluído o processo, converto hResult em Json */
    //AP_SetContentType( "application/json" ) 
    ?? hb_JsonEncode( hResult )

RETURN 
/*************/