﻿#define adOpenForwardOnly 0
#define adOpenKeyset 1
#define adOpenDynamic 2
#define adOpenStatic 3
#define adLockReadOnly 1
#define adLockPessimistic 2
#define adLockOptimistic 3
#define adLockBatchOptimistic 4
#define adUseNone 1
#define adUseServer 2
#define adUseClient 3
#define adStateClose 

#xtranslate TEXT SQL TO <v>  => #pragma __text|<v>+=%s;<v>:="" 

function main

   LOCAL oCn, cSql
   LOCAL cString := "Driver={Microsoft Access Driver (*.mdb, *.accdb)};DBQ=" + PathBase() + "/scott.mdb"
   LOCAL hPost:= AP_PostPairs()
   LOCAL oError
   LOCAL hRet := { => }
   LOCAL cOper
   
   IF .NOT. hb_HHasKey( hPost , "___pk" )
       hRet["Result"] := "ERRO"
       hRet["Message"] := "Operação indefinida : " + hb_valtoexp(hPost)
       ?? hb_JsonEncode( hRet )
       RETURN
   ENDIF
   
   IF .NOT. EMPTY( hPost["___pk"] ) // UPDATE PORQUE VEM COM A CHAVE PRIMÁRIA PREENCHIDA
      TEXT SQL TO cSQL
          UPDATE emp
          SET ename = ':ename',
              job = ':job',
              deptno = :deptno
          WHERE empno = :empno    
      ENDTEXT   
      cSQL := StrTran( cSQL , ":empno" , hPost["___pk"] )
   
   ELSE
      TEXT SQL TO cSQL
          INSERT INTO emp 
            ( 
            empno,
            ename,
            job,
            deptno
            )
          VALUES
            ( 
            :empno,
            ':ename',
            ':job',
            :deptno 
            )
      ENDTEXT
      cSQL := StrTran( cSQL , ":empno" , hb_ntos(hb_RandomInt(1000,9999999)) ) // Em projetos reais evite isso, prefira um campo autonumerado.
   ENDIF

   cSQL := StrTran( cSQL , ":ename" , hPost["ename"] )
   cSQL := StrTran( cSQL , ":job" , hPost["job"] )
   cSQL := StrTran( cSQL , ":deptno" , hPost["deptno"] )
   
   BEGIN SEQUENCE WITH __BreakBlock()
       oCn := win_oleCreateObject( "ADODB.Connection" ) 
       oCn:ConnectionString := cString
       oCn:Open()
       oCn:Execute( cSQL )
       oCn:Close()   
       hRet["Result"] := "OK"
       hRet["Message"] := "Operação realizada com sucesso : " + cSQL
   RECOVER USING oError
       hRet["Result"] := "ERRO"
       hRet["Message"] := oError:Description + " / " + cSQL
   END SEQUENCE    
    
   ?? hb_JsonEncode( hRet )

return nil

