﻿#define adOpenForwardOnly 0
#define adOpenKeyset 1
#define adOpenDynamic 2
#define adOpenStatic 3
#define adLockReadOnly 1
#define adLockPessimistic 2
#define adLockOptimistic 3
#define adLockBatchOptimistic 4
#define adUseNone 1
#define adUseServer 2
#define adUseClient 3
#define adStateClose 

#xtranslate TEXT SQL TO <v>  => #pragma __text|<v>+=%s;<v>:="" 
/*
Definições da busca genérica
*/
PROCEDURE Main

   LOCAL oRs , oCn, cSql
   LOCAL cString := "Driver={Microsoft Access Driver (*.mdb, *.accdb)};DBQ=" + PathBase() + "/scott.mdb"
   LOCAL hReg 
   LOCAL hGet := AP_GetPairs()
   LOCAL aReg := { {} , {} }
   LOCAL hResult
   

   oCn := win_oleCreateObject( "ADODB.Connection" ) 
   oCn:ConnectionString := cString
   oCn:Open()
   
   oRs := win_oleCreateObject( "ADODB.Recordset" ) 
   oRs:CursorLocation = adUseClient
   
   IF hb_HHasKey( hGet , "word" )
   ELSE
        hResult["Result"] := "ERRO"
        hResult["Message"] := "O termo não foi informado"
        ?? hb_JsonEncode( hResult )
        RETURN
   ENDIF

   /*************************/ 
     
   TEXT SQL TO cSQL
      
        SELECT deptno, dname
            FROM dept
        WHERE dname LIKE '%:word%'    
        ORDER BY dname ASC
   
   ENDTEXT
   cSql := StrTran( cSql , ":word" , hGet["word"] )
   
   
  
   oRs:Open( cSQL , oCn , adOpenDynamic, adLockOptimistic )

   if oRs:recordcount > 0
        oRs:Movefirst()
        IF !oRs:eof()
            do while !oRs:eof()
                hReg := {=>}
                /*
                0 = Código
                1 = Descricao
                */
                //AAdd( aReg[1] , oRs:Fields( 0 ):value )
                //AAdd( aReg[2] , oRs:Fields( 1 ):value )
                aadd( aReg , { "value" => oRs:Fields( 0 ):value , "label" =>  oRs:Fields( 1 ):value } )
                oRs:movenext()
            enddo    
        ENDIF
    endif    
    oRs:Close()
    
    
    /* Agora vou preparar o retorno no formato JSON. Primeiro o Hash hResult
       vai acumular os valores */
    hResult := { => }
    
   
    hResult[ "Result" ] := "OK"
    hResult[ "Rows" ] := aReg 
    
    /* Depois de concluído o processo, converto hResult em Json */
    //AP_SetContentType( "application/json" ) 
    ?? hb_JsonEncode( hResult )

RETURN 
/*************/